unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, OleCtrls, WMPLib_TLB, StdCtrls, ExtCtrls, ComCtrls, Menus,
  ImgList, AppEvnts;

type
  TForm1 = class(TForm)
    player: TWindowsMediaPlayer;
    OpenDialog1: TOpenDialog;
    StatusBar1: TStatusBar;
    ListBox1: TListBox;
    MainMenu1: TMainMenu;
    N1: TMenuItem;
    N2: TMenuItem;
    N3: TMenuItem;
    N4: TMenuItem;
    ApplicationEvents1: TApplicationEvents;
    N5: TMenuItem;
    N6: TMenuItem;
    N7: TMenuItem;
    N8: TMenuItem;
    N9: TMenuItem;
    N10: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure playerPlayStateChange(Sender: TObject; NewState: Integer);
    procedure playerOpenStateChange(Sender: TObject; NewState: Integer);
    procedure playerStatusChange(Sender: TObject);
    procedure playerMediaChange(Sender: TObject; const Item: IDispatch);
    procedure FormDestroy(Sender: TObject);
    procedure N2Click(Sender: TObject);
    procedure N3Click(Sender: TObject);
    procedure N4Click(Sender: TObject);
    procedure ApplicationEvents1Idle(Sender: TObject; var Done: Boolean);
    procedure N6Click(Sender: TObject);
    procedure N7Click(Sender: TObject);
    procedure N8Click(Sender: TObject);
    procedure N9Click(Sender: TObject);
    procedure N10Click(Sender: TObject);
    procedure playerClick(Sender: TObject; nButton, nShiftState: Smallint;
      fX, fY: Integer);
  private
    procedure   ShowStatus(const S: string; const index: integer);
  public
    FSList: TStringList;
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

//  ---------------------------------------------------------------------------
//  EBhE
procedure   SimpleMessage(const S: string);
var
    Flag: integer;
begin
    Flag := MB_OK + MB_ICONINFORMATION;
    Application.MessageBox(PChar(S), PChar(Application.Title), Flag);
end;

//  ---------------------------------------------------------------------------
//  Xe[^Xo[ɃbZ[W\
procedure   TForm1.ShowStatus(const S: string; const index: integer);
begin
    if (Assigned(StatusBar1)) then
    begin
        StatusBar1.Panels[index].Text := S;
    end;
end;

//  ---------------------------------------------------------------------------
//  ON/OFF\pz
const
    ON_OFF: array[Boolean] of string = ('OFF', 'ON');
    OK_NG: array[Boolean] of string = ('NG', 'OK');

//  ---------------------------------------------------------------------------
//  vC[̐ݒ𒲂ׂ
procedure TForm1.N2Click(Sender: TObject);
var
    b: Boolean;
    s: string;
    i: integer;
    d: double;
begin
    FSList.Clear;

    //  o[W
    s := player.versionInfo;
    FSList.Add(s);

    //  Đ(ύX\)
    b := player.settings.autoStart;
    s := Format('Đ = %s', [ON_OFF[b]]);
    FSList.Add(s);

    //  oX(ύX\)
    i := player.settings.balance;
    s := Format('XeIoX(-100..100) = %d', [i]);
    FSList.Add(s);

    //  G[_CAO(ύX\)
    b := player.settings.enableErrorDialogs;
    s := Format('G[_CAO\ = %s', [ON_OFF[b]]);
    FSList.Add(s);

    //  ~[g(ύX\)
    b := player.settings.mute;
    s := Format('~[g = %s', [ON_OFF[b]]);
    FSList.Add(s);

    //  Đ(ύX\)
    i := player.settings.playCount;
    s := Format('Đ = %d', [i]);
    FSList.Add(s);

    //  Đx(ύX\)
    d := player.settings.rate;
    s := Format('Đx = %f', [d]);
    FSList.Add(s);

    b := player.settings.isAvailable['Rate'];
    if (b) then
        s := 'ĐxύX = \'
    else
        s := 'ĐxύX = s';
    FSList.Add(s);

    //  (ύX\)
    i := player.settings.volume;
    s := Format(' = %d', [i]);
    FSList.Add(s);

    //  [v[h(ύX\)
    b := player.settings.getMode('loop');
    s := Format('[vĐ[h = %s', [ON_OFF[b]]);
    FSList.Add(s);

    //  Vbt[h(ύX\)
    b := player.settings.getMode('shuffle');
    s := Format('_Đ[h = %s', [ON_OFF[b]]);
    FSList.Add(s);

    SimpleMessage(FSList.Text);
end;

//  ---------------------------------------------------------------------------
//  fBAɊւ
procedure TForm1.N3Click(Sender: TObject);
var
    i, w, h: integer;
    s: string;
begin
    FSList.Clear;

    //  Đ̃fBA邩ǂ
    if (player.currentMedia = nil) then
    begin
        s := 'Đ̃fBA܂B';
        FSList.Add(s);
    end
    else
    begin
        //  
        w := player.currentMedia.imageSourceWidth;
        h := player.currentMedia.imageSourceHeight;
        FSList.Add(Format(' = %d;  = %d', [w, h]));

        //  fBA̖O
        FSList.Add(Format('O = %s', [player.currentMedia.name]));
        //  URL
        FSList.Add(Format('URL  = %s', [player.currentMedia.sourceURL]));

        //  񋓂ł鑮
        for i := 0 to player.currentMedia.attributeCount - 1 do
        begin
            s := player.currentMedia.getAttributeName(i);
            FSList.Add(Format('%-20s = %s', [s, player.currentMedia.getItemInfo(s)]));
        end;

    end;

    SimpleMessage(FSList.Text);
end;

//  ---------------------------------------------------------------------------
//  w肵̎ނp\A܂͎w肵삪s\ǂ𔻒f
procedure TForm1.N4Click(Sender: TObject);
var
    b: Boolean;
    s: string;
begin
    FSList.Clear;

    //  Đł邩
    b := player.controls.isAvailable['Play'];
    s := Format('%s = %s', [OK_NG[b], 'player.controls.play();']);
    FSList.Add(s);

    //  ꎞ~ł邩
    b := player.controls.isAvailable['Pause'];
    s := Format('%s = %s', [OK_NG[b], 'player.controls.pause();']);
    FSList.Add(s);

    //  ~ł邩
    b := player.controls.isAvailable['Stop'];
    s := Format('%s = %s', [OK_NG[b], 'player.controls.stop();']);
    FSList.Add(s);

    //  (rate = 5)Đł邩
    b := player.controls.isAvailable['FastForward'];
    s := Format('%s = %s', [OK_NG[b], 'player.controls.fastForward();']);
    FSList.Add(s);

    //  ߂(rate = 5)Đł邩
    b := player.controls.isAvailable['FastReverse'];
    s := Format('%s = %s', [OK_NG[b], 'player.controls.fastReverse();']);
    FSList.Add(s);

    //  vCXg̎̃fBAɂ邩
    b := player.controls.isAvailable['Next'];
    s := Format('%s = %s', [OK_NG[b], 'player.controls.next();']);
    FSList.Add(s);

    //  vCXg̑ÕfBAɂ邩
    b := player.controls.isAvailable['Previous'];
    s := Format('%s = %s', [OK_NG[b], 'player.controls.previous();']);
    FSList.Add(s);

    //  ݈ʒuύXł邩
    b := player.controls.isAvailable['CurrentPosition'];
    s := Format('%s = %s', [OK_NG[b], 'player.controls.currentPosition();']);
    FSList.Add(s);

    SimpleMessage(FSList.Text);
end;

//  ---------------------------------------------------------------------------
//  Đ̃fBA̎ԂɊւ
procedure TForm1.ApplicationEvents1Idle(Sender: TObject;
  var Done: Boolean);
var
    s, s1, s2: string;
    d1, d2: double;
begin
    //  Đ̃fBA邩ǂ
    if (player.currentMedia <> nil) then
    begin
        //  ݂̃fBAڂ̕bŎĐ(b)
        s1 := player.currentMedia.durationString;
        //  fBAړ݈̌ʒu擾(b)
        s2 := player.controls.currentPositionString;
        if (s2 = '') then s2 := '00:00';
        //  ݂̃fBAڂ̕bŎĐ
        d1 := player.currentMedia.duration;
        //  fBAړ݈̌ʒu擾(ύX\)
        d2 := player.controls.currentPosition;
        //  A
        s := Format('%s(%fb) / %s(%fb)', [s2, d2, s1, d1]);

        ShowStatus(s, 1);
    end;
end;

//  ---------------------------------------------------------------------------
//  vCXgɃt@Cǉ
procedure TForm1.N6Click(Sender: TObject);
var
    i: integer;
    Media: IWMPMedia;
begin
    //  t@CI
    if OpenDialog1.Execute then
    begin
        //  ƂȒPȒǉ@(1t@C)
        //player.URL := OpenDialog1.FileName;
        //  SẴt@Cɂ
        for i := 0 to OpenDialog1.Files.Count - 1 do
        begin
            try
                //  vCXgɒǉ邽߂MediaIuWFNg쐬
                Media := player.mediaCollection.add(OpenDialog1.Files[i]);
                //  vCXgɒǉ
                player.currentPlaylist.appendItem(Media);
                //  p̃Xg{bNXɂǉ
                ListBox1.Items.Add(Media.name + '=' + Media.sourceURL);
            except
                //  Ήt@C͖
                ;
            end;
        end;
        //  ōĐ
        player.controls.play();
    end;
end;

//  ---------------------------------------------------------------------------
//  IfBAĐ
procedure TForm1.N7Click(Sender: TObject);
begin
    if (ListBox1.ItemIndex = -1) then exit;
    //  Ôߍ̃fBA~Ă
    player.controls.stop;
    //  fBA؂ւ
    player.controls.currentItem := player.currentPlaylist.Item[ListBox1.ItemIndex];
    //  ŁAĐ
    player.controls.play;
end;

//  ---------------------------------------------------------------------------
//  IfBA폜
procedure TForm1.N8Click(Sender: TObject);
var
    Media: IWMPMedia;
begin
    if (ListBox1.ItemIndex = -1) then exit;
    //  IfBAo
    Media := player.currentPlaylist.Item[ListBox1.ItemIndex];
    //  vCXg炻̃fBA폜
    player.currentPlaylist.removeItem(Media);
    //  Xg{bNX폜Ă
    ListBox1.DeleteSelected;
end;

//  ---------------------------------------------------------------------------
//  ĐXǧ݂̍ڂ̈ʒuA̍ڂ
procedure TForm1.N9Click(Sender: TObject);
begin
    player.controls.next();
end;

//  ---------------------------------------------------------------------------
//  ĐXǧ݂̍ڂ̈ʒuA1 O̍ڂ
procedure TForm1.N10Click(Sender: TObject);
begin
    player.controls.previous();
end;

//  ---------------------------------------------------------------------------
//  RXgN^
procedure TForm1.FormCreate(Sender: TObject);
begin
    FSList := TStringList.Create;
end;

//  ---------------------------------------------------------------------------
//  RXgN^
procedure TForm1.FormDestroy(Sender: TObject);
begin
    FSList.Free;
end;

//  ---------------------------------------------------------------------------
//  fBAύXꂽ
procedure TForm1.playerMediaChange(Sender: TObject; const Item: IDispatch);
begin
    Self.Caption := Application.Title + ' : ' + (Item as IWMPMedia).name;
end;

//  ---------------------------------------------------------------------------
//  Windows Media Player ̏ԕύX
procedure TForm1.playerPlayStateChange(Sender: TObject; NewState: Integer);
const
    //  SDK ̂܂܂̐
    PLAY_STATE_STR: array[0..10] of string
    = ('Undefined',   'Stopped',   'Paused',  'Playing',    'ScanForward',
       'ScanReverse', 'Buffering', 'Waiting', 'MediaEnded', 'Transitioning',
       'Ready');
var
    s: string;
begin
    if (Low(PLAY_STATE_STR) <= NewState) and (NewState <= High(PLAY_STATE_STR)) then
        s := PLAY_STATE_STR[NewState]
    else
        s := 'Unknown';
    ShowStatus('PlayState is ' + s, 0);
end;

//  ---------------------------------------------------------------------------
//  Rec\[X̏Ԃl擾
procedure TForm1.playerOpenStateChange(Sender: TObject; NewState: Integer);
const
    OPEN_STATE_STR: array[0..21] of string
    = ('Undefined',               'PlaylistChanging',       'PlaylistLocating',
       'PlaylistConnecting',      'PlaylistLoading',        'PlaylistOpening',
       'PlaylistOpenNoMedia',     'PlaylistChanged',        'MediaChanging',
       'MediaLocating',           'MediaConnecting',        'MediaLoading',
       'MediaOpening',            'MediaOpen',              'BeginCodecAcquisition',
       'EndCodecAcquisition',     'BeginLicenseAcquisition','EndLicenseAcquisition',
       'BeginIndividualization',  'EndIndividualization',   'MediaWaiting',
       'OpeningUnknownURL');
var
    s: string;
begin
    if (Low(OPEN_STATE_STR) <= NewState) and (NewState <= High(OPEN_STATE_STR)) then
        s := OPEN_STATE_STR[NewState]
    else
        s := 'Unknown';
    ShowStatus('OpenState is ' + s, 0);
end;

//  ---------------------------------------------------------------------------
//  Windows Media Player ̏ԕύX
procedure TForm1.playerStatusChange(Sender: TObject);
begin
    ShowStatus(player.status, 0);
end;

//  ---------------------------------------------------------------------------
//  ĐE~
procedure TForm1.playerClick(Sender: TObject; nButton,
  nShiftState: Smallint; fX, fY: Integer);
begin
    if (player.controls.isAvailable['Play']) then
    begin
        player.controls.play();
    end
    else if (player.controls.isAvailable['Pause']) then
    begin
        player.controls.pause();
    end;
end;

end.

